local MAIN_SKIN= "jolteon"
local DROP_OBJ_ATTR= MAIN_SKIN..'dropped_obj'

if not this_template_allocation_run_only_once_give_a_unique_name_jolteon then
	rawset(_G, "this_template_allocation_run_only_once_give_a_unique_name_jolteon", true)
	
	freeslot("MT_DROPPED_JOLTBO")
	freeslot("S_DROPPED_JOLTBO")
end

addHook("TouchSpecial", function(special, toucher)
	if (toucher and (toucher.momx or toucher.momy)) then
		special.momx = toucher.momx
		special.momy = toucher.momy
		special.momz = P_AproxDistance(toucher.momx, toucher.momy)/4
		if (toucher.momz > 0) then
			special.momz = $1 + toucher.momz/8;
		end
	end
	return true
end, MT_DROPPED_JOLTBO)

addHook("MobjThinker", function(mo)
	local target = mo.target
	if not(target and target.valid and target.player and
			target.skin==MAIN_SKIN and
			(target.player.kartstuff[k_spinouttimer] or target.player.playerstate==PST_DEAD)
		)
	then
		P_RemoveMobj(mo)
		return
	end
end, MT_DROPPED_JOLTBO)

local function spawn_object(player)
	local dropped_object= P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z+40*FRACUNIT, MT_DROPPED_JOLTBO)
	dropped_object.target= player.mo
    dropped_object.friction = 60*FRACUNIT/100
	dropped_object.color= player.skincolor
	P_SpawnShadowMobj(dropped_object)
end

addHook("ThinkFrame", do
	for player in players.iterate do
		if (not player.mo) or player.mo.skin~=MAIN_SKIN then continue end
		
		if (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
				and (not player[DROP_OBJ_ATTR])
		then
			player[DROP_OBJ_ATTR]= true
			spawn_object(player)
		elseif not (player.kartstuff[k_spinouttimer] or player.playerstate==PST_DEAD)
			and player[DROP_OBJ_ATTR]
		then
			player[DROP_OBJ_ATTR]= nil
		end
	end
end)


//----------------------------------------------------------------

//Optimization credits go to DarkyBenji because i don't know what i'm doing
//Also features better acrobasics compatibility so no he didn't do everything lmao

local tauntskins = "jolteon"
local TICRATE = TICRATE

-------------------------------------------------------------------
//Functions
-------------------------------------------------------------------
local function AltSpin(p)
   if not p.mo or not p.mo.valid then return end   
   if p.playerstate == PST_DEAD
       if p.mo.frame == Q
	     p.mo.frame = T
	   end
	 end
	 if p.kartstuff[k_spinouttimer] 
       if p.mo.frame == Q
	     p.mo.frame = T
	   end
	 end
end

-------------------------------------------------------------------
//ThinkFrame and Timer Shit
-------------------------------------------------------------------
local function KillTaunt(p)
	if p.kartstuff[k_spinouttimer] 
	or p.playerstate == PST_DEAD
	or p.kartstuff[k_squishedtimer]
	or (acrobatics != nil and p.trickactive)
	or (acrobasics != nil and p.hastricked)
	then return true
	else return false
	end
end

addHook("MapLoad", do     
    for player in players.iterate do
        player.taunttimer = nil
    end
end) 

addHook("ThinkFrame", do
    for p in players.iterate do    
        if not p.mo or not p.mo.valid continue end 
		if (p.mo.skin != tauntskins) or p.spectator continue end //Stop working. You have no use to me.
		
        if p.taunttimer == nil or KillTaunt(p) then p.taunttimer = 0 end //Reset
		if p.taunttimer > 0 then p.taunttimer = max($-1, 0) end //Timer
		//print(p.taunttimer)
		
		AltSpin(p)
    end
end)

-------------------------------------------------------------------
//Playerblablabla
-------------------------------------------------------------------
local function Gottem(player, inflictor, source)
  if not (source and source.player) then return end

  if source.player != player
    if (source.player.mo and source.player.mo.valid) and (source.player.mo.skin == tauntskins)
      if not (source.player.kartstuff[k_spinouttimer] and source.player.kartstuff[k_squishedtimer])
        source.player.taunttimer = TICRATE
      end
    end
  end
end
addHook("PlayerSpin", Gottem)
addHook("PlayerExplode", Gottem)
addHook("PlayerSquish", Gottem)